/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.test.remoting.tests;

import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.MulticastSocket;
import java.net.SocketAddress;

import junit.framework.TestCase;

import org.apache.log4j.Logger;


public class MulticastDetectorTest extends TestCase
{
   private static Logger log = Logger.getLogger(MulticastDetectorTest.class);
   
   
   public static void main(String[] args) throws Throwable
   {
      String defaultIP = "224.1.9.1";
      int port = 2410;
      MulticastSocket socket;
      
      InetAddress localHost = InetAddress.getLocalHost();
      SocketAddress saddr = new InetSocketAddress(localHost, port);
      socket = new MulticastSocket(saddr);
      InetAddress addr = InetAddress.getByName(defaultIP);
      socket.joinGroup(addr);
      
      byte buf[] = new byte[8];
      DatagramPacket p = new DatagramPacket(buf, buf.length, addr, port);
      while (true)
      {
         log.info("sending to multicast group");
         socket.send(p);
         Thread.sleep(1000);
      }
   }
}