package org.jboss.test.remoting.tests;

import java.util.HashMap;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.jboss.remoting.Client;
import org.jboss.remoting.ConnectionListener;
import org.jboss.remoting.ConnectionValidator;
import org.jboss.remoting.InvokerLocator;

public class NetworkDisconnectTimeoutTestClient
{
   static Logger log = Logger.getLogger(NetworkDisconnectTimeoutTestClient.class);
   
   public static void main(String[] args)
   {
      try
      {
         Logger.getLogger("org.jboss.remoting").setLevel(Level.INFO);
         Logger.getLogger("org.jboss.test.remoting").setLevel(Level.INFO);
         String pattern = "[%d{ABSOLUTE}] [%t] %5p (%F:%L) - %m%n";
         PatternLayout layout = new PatternLayout(pattern);
         ConsoleAppender consoleAppender = new ConsoleAppender(layout);
         Logger.getRootLogger().addAppender(consoleAppender);
         
//         Client client = new Client(new InvokerLocator("socket://192.168.2.5:5555/?timeout=5000"));
         Client client = new Client(new InvokerLocator("socket://192.168.2.5:5555"));
         client.connect();
         HashMap metadata = new HashMap();
         metadata.put(ConnectionValidator.VALIDATOR_PING_PERIOD, "1000");
         metadata.put(ConnectionValidator.VALIDATOR_PING_TIMEOUT, "1000");
         client.addConnectionListener(new Listener(client), metadata);
         log.info("making invocation");
         long start = System.currentTimeMillis();
         log.info("result: " + client.invoke("abc"));
         log.info("elapsed with ConnectionValidator: " + (System.currentTimeMillis() - start));
      }
      catch (Throwable e)
      {
         log.info(" exception", e);
      }
   }

   static class Listener implements ConnectionListener
   {
      Client client;
      
      public Listener(Client client)
      {
         this.client = client;
      }
      
      public void handleConnectionException(Throwable throwable, Client client)
      {
         log.info(this + " received connection exception: disconnecting " + this.client);
         this.client.disconnect();
         log.info(this + " disconnected " + client);
      }  
   }
}
