package org.jboss.test.remoting.tests;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.jboss.logging.XLevel;
import org.jboss.remoting.InvokerLocator;
import org.jboss.remoting.transport.Connector;

public class RecreatedLocatorTest
{
   public static void main(String[] args) {
      Logger.getLogger("org.jboss.remoting").setLevel(XLevel.DEBUG);
      Logger.getLogger("org.jboss.test.remoting").setLevel(Level.INFO);
      String pattern = "[%d{ABSOLUTE}] [%t] %5p (%F:%L) - %m%n";
      PatternLayout layout = new PatternLayout(pattern);
      ConsoleAppender consoleAppender = new ConsoleAppender(layout);
      Logger.getRootLogger().addAppender(consoleAppender);  
      
      try
      {
         String locatorURI = "socket://0.0.0.0:4444";
         InvokerLocator serverLocator = new InvokerLocator(locatorURI);
         Connector connector = new Connector(serverLocator);
         connector.create();

         locatorURI = "socket://localhost:6666";
         serverLocator = new InvokerLocator(locatorURI);
         connector = new Connector(serverLocator);
         connector.create();
         
         connector.stop();
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }

   }
}
