package org.jboss.test.remoting.tests;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;

public class ZeroTimeoutTest
{
   private static Logger log = Logger.getLogger(ZeroTimeoutTest.class);
   /**
    * @param args
    */
   public static void main(String[] args)
   {
      Logger.getLogger("org.jboss.remoting").setLevel(Level.INFO);
      Logger.getLogger("org.jboss.test.remoting").setLevel(Level.INFO);
      String pattern = "[%d{ABSOLUTE}] [%t] %5p (%F:%L) - %m%n";
      PatternLayout layout = new PatternLayout(pattern);
      ConsoleAppender consoleAppender = new ConsoleAppender(layout);
      Logger.getRootLogger().addAppender(consoleAppender);  
      
      Thread t = new Thread() {
         public void run() {
            try {
               ServerSocket ss = new ServerSocket(5555);
               Socket s = ss.accept();
               log.info("got socket: " + s);
               OutputStream os = s.getOutputStream();
               ObjectOutputStream oos = new ObjectOutputStream(os);
               oos.writeInt(7);
               s.close();
               log.info("closed socket: " + s);
            } catch (IOException e) {
               log.error(e.getMessage(), e);
            }
         }
      };
      t.start();
      try
      {
         Thread.sleep(2000);
         Socket s = new Socket("localhost", 5555);
//         s.setSoTimeout(0);
         InputStream is = s.getInputStream();
         ObjectInputStream ois = new ObjectInputStream(is);
         log.info("timeout: " + s.getSoTimeout());
         log.info("starting read()");
         int i = ois.readInt();
         log.info("done reading: " + i);
         log.info("starting read()");
         i = ois.readInt();
         log.info("done reading: " + i);
      }
      catch (Exception e)
      {
         log.error(e.getMessage(), e);
      }
   }
   

}
